-- Oba ponizsze przyklady spowoduja oczywiscie blad
-- Patrzymy w obu przypadkach na ilosc dopisanych wierszy (wynik instrukcji select)

-- Tabela powinna byc utworzona przy wykorzystaniu kodu:
drop table liczby;
go

create table liczby ( liczba int check ( liczba<=20 ) )
go

-- 1 --
delete from liczby;
begin tran
insert into liczby(liczba) values(1);
insert into liczby(liczba) values(2);
insert into liczby(liczba) values('a');
commit tran
go
-- 
select count(*) from liczby

-- 2 --
delete from liczby;
begin tran
insert into liczby(liczba) values(1);
insert into liczby(liczba) values(2);
insert into liczby(liczba) values(30);
commit tran
go
--
select count(*) from liczby

-- 3 --
-- Przyklad 2, tylko ze z obsluga bledow
-- goto uzyjemy, jesli bedziemy chcieli wykonac dalej jakis jeszcze kod
delete from liczby;
go

begin tran
insert into liczby(liczba) values(1);
if ( @@error<>0 )
begin
  print 'Nie udalo sie wstawic 1';
  rollback transaction
  return
--  goto on_error
end
insert into liczby(liczba) values(2);
if ( @@error<>0 )
begin
  print 'Nie udalo sie wstawic 2';
  rollback transaction
  return
--  goto on_error
end
insert into liczby(liczba) values(30);
if ( @@error<>0 )
begin
  print 'Nie udalo sie wstawic 30';
  rollback transaction
  return
--  goto on_error
end
insert into liczby(liczba) values(3);
commit tran
--on_error
go
--
select count(*) from liczby

-- 4 --
-- Tutaj mamy sytuacje, w ktorej zapytanie ma blad skladniowy (zla nazwa tabeli),
-- ale zostanie on wykryty dopiero na etapie wykonania
declare @tabela varchar(20)
set @tabela='liczby2'
execute('use tempdb; select * from '+@tabela+' print ''Komunikat 1'' ');
print 'Komunikat 2'
go

-- 5 --
-- Konstrukcja:
-- declare @retcode int
-- exec @retcode=procedura

drop procedure wstaw
go

create procedure wstaw(@arg1 int, @arg2 int) as
begin
  begin transaction
  insert tempdb..liczby(liczba) values(@arg1+@arg2)
  if ( @@error<>0 ) goto on_error
  insert tempdb..liczby(liczba) values(@arg1*@arg2)
  if ( @@error<>0 ) goto on_error
  commit transaction
  return(0);
  on_error:
  print 'Pojawil sie blad';
  rollback transaction
  return(1);
end
go

set xact_abort on --off --on
delete from tempdb..liczby
declare @retcode int
execute @retcode=wstaw 9, 5 -- w-czenie opcji xact_abort sprawi, e tutaj wsad bdzie przerwany
print 'Kod wyjscia: '+cast( @retcode as varchar )
go

select * from tempdb..liczby
